import structure.*;
import element.*;

public class Illusions
{
    static DrawingWindow d;
    public static void main(String args[])
    {
        d = new DrawingWindow();
        kanizsa();
        d = new DrawingWindow();
        board(8,16);
        d = new DrawingWindow();
        konigNecklace();
    }
    
    public static void board(int vlines, int hlines)
    {   
        horizLines(hlines);
        thinVertLines(vlines);
        thinBlackVertLines(vlines);
        thinHorizLines(hlines);
    }


    public static void vase()
    {
        d.fill(d.bounds());
        d.clear(new Rect(50,35,100,50));

        d.fill(new Oval(25,35,50,100));
        d.fill(new Oval(125,35,50,100));

        d.clear(new Oval(75,65,50,40));

        d.clear(new Rect(90,100,20,60));

        d.clear(new Oval(80,115,40,30));
        d.clear(new Oval(76,126,48,10));

        d.fill(new Oval(82,104,13,12));
        d.fill(new Oval(105,104,13,12));

        d.fill(new Oval(83,143,10,12));
        d.fill(new Oval(107,143,10,12));
        d.clear(new Arc(new Oval(55,155,90,20),0,180));
    }

    public static void kanizsa()
    {
        int s = (int)(Math.sin(Math.PI/6.0)*50);
        int l = (int)(Math.cos(Math.PI/6.0)*50);
        int r = 20;

        d.fill(new Circle(100,50,r));
        d.fill(new Circle(100-l,100+s,r));
        d.fill(new Circle(100+l,100+s,r));

        d.moveTo(100-l,100-s);
        d.lineTo(100+l,100-s);
        d.lineTo(100,150);
        d.lineTo(100-l,100-s);

        d.clear(new Arc(new Circle(100,50,50),-60,-60));
        d.clear(new Arc(new Circle(100-l,100+s,50),0,60));
        d.clear(new Arc(new Circle(100+l,100+s,50),120,60));
    }

    public static void centerCircle(int lines)
    {
        checkerBoard(lines);
        d.invertMode();
        d.fill(new Circle(100,100,50));
        d.paintMode();
    }

    public static void horizLines(int lines)
    {
        int i;
        d.invertMode();
        for (i = 0; i < lines/2; i++)
        {
            d.fill(new Rect(0,(2*i+1)*(200/lines),200,200/lines));
        }
        d.paintMode();
    }

    public static void thinHorizLines(int lines)
    {
        int i;
        d.invertMode();
        for (i = 1; i <= lines; i++)
        {
            d.moveTo(0,i*(200/lines));
            d.line(200,0);
        }
        d.paintMode();
    }

    public static void vertLines(int lines)
    {
        int i;
        d.invertMode();
        for (i = 0; i < lines/2; i++)
        {
            d.fill(new Rect(i*400/lines,0,200/lines,200));
        }
        d.paintMode();
    }

    public static void thinVertLines(int lines)
    {
        int i;
        d.invertMode();
        for (i = 0; i < lines/2; i++)
        {
            d.fill(new Rect(i*400/lines,0,100/lines+1,200));
        }
        d.paintMode();
    }

    public static void thinBlackVertLines(int lines)
    {
        int i;
        for (i = 0; i < lines/2; i++)
        {
            d.fill(new Rect(i*400/lines+100/lines+1,0,100/lines,200));
        }
        for (i = 0; i < lines/2; i++)
        {
            d.clear(new Rect(i*400/lines+300/lines+1,0,100/lines,200));
        }
    }

    public static void toughCirc(int lines)
    {
        checkerBoard(lines);
        d.clear(new Circle(100,100,50));
        vertLines(lines);
    }

    public static void perspCheckerBoard(int lines)
    {
        rays(lines);
        horizLines(lines);
    }

    public static void rays(int lines)
    {
        int i;
        d.invertMode();
        for (i = 0; i < 5; i++)
        {       
            d.fill(new Arc(new Circle(100,-100,400),
                           5*(2*i+1)-90,
                           -(10+20*i)));
        }
        d.paintMode();
    }

    public static void checkerBoard(int lines)
    {
        vertLines(lines);
        horizLines(lines);
    }


    public static void konigNecklace()
    {
        Circle l = new Circle(100,100,10);
        l.top(100);
        d.draw(l);
        Circle r = new Circle(l);
        l.move(-22,-2);
        l.extend(-2,-2);
        d.draw(l);
        l.move(-19,-2);
        l.extend(-2,-2);
        d.draw(l);
        l.move(-15,-2);
        l.extend(-2,-2);
        d.draw(l);
        r.move(22,-2);
        r.extend(-2,-2);
        d.draw(r);
        r.move(19,-2);
        r.extend(-2,-2);
        d.draw(r);
        r.move(15,-2);
        r.extend(-2,-2);
        d.draw(r);
    }
    public static void mullerLyer()
    {
        d.draw(new Line(50,100,150,100));
        d.moveTo(50,100);
        d.line(-20,-20);
        d.moveTo(50,100);
        d.line(-20,20);
        d.moveTo(100,100);
        d.line(20,-20);
        d.moveTo(100,100);
        d.line(20,20);
        d.moveTo(150,100);
        d.line(-20,-20);
        d.moveTo(150,100);
        d.line(-20,20);
    }
    public static void poggendorff()
    {   // use one rect
        d.draw(new Line(10,60,90,140));
        d.draw(new Line(110,60,190,140));
                
        d.clear(new Rect(37,50,25,100));
        d.clear(new Rect(121,50,25,100));
        d.clear(new Rect(155,50,25,100));
        d.draw(new Rect(37,50,25,100));
        d.draw(new Rect(121,50,25,100));
        d.draw(new Rect(155,50,25,100));
    }
    public static void necker()
    {   // could be improved with three types of lines, offset?
        d.draw(new Line(40,60,120,40));
        d.moveTo(40,60);
        d.line(80,-20);
        d.moveTo(60,100);
        d.line(80,-20);
        d.moveTo(40,120);
        d.line(80,-20);
        d.moveTo(60,160);
        d.line(80,-20);
        d.moveTo(40,60);
        d.line(0,60);
        d.moveTo(120,40);
        d.line(0,60);
        d.moveTo(60,100);
        d.line(0,60);
        d.moveTo(140,80);
        d.line(0,60);
        d.moveTo(40,60);
        d.line(20,40);
        d.moveTo(120,40);
        d.line(20,40);
        d.moveTo(40,120);
        d.line(20,40);
        d.moveTo(120,100);
        d.line(20,40);
    }
}
//1-888-USA4Y2K
